/*
 
 Copyright (C) 2010 Timo Lassmann <timolassmann@gmail.com>
 
 This file is part of delve.
 
 Delve is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 Delve is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with Delve.  If not, see <http://www.gnu.org/licenses/>.
 
 */


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <float.h>
#include <string.h>



#define MAX(a, b) (a > b ? a : b)
#define MAX3(a,b,c) MAX(MAX(a,b),c)
#define MAX4(a,b,c,d) MAX(MAX(MAX(a,b),c),d)

struct states{
	float a;
	float ga;
	float gb;
};

struct hirsch_mem{
	struct states* f;
	struct states* b; 
	float score;
	int* path;
	char* pline;
	int starta;
	int startb;
	int enda;
	int endb;
	int size;
	int len_a;
	int len_b;
};

void align(unsigned char* q_name,unsigned char* q,unsigned char* qual, int q_len,unsigned char*t_name,unsigned char* t, int t_len ,int pos,struct hirsch_mem* hm,unsigned short int strand);
void print_aln(struct hirsch_mem* hm,unsigned char * q_name,unsigned char* q,unsigned char* qual, int q_len,unsigned char* t_name,unsigned char* t, int pos, unsigned short int strand);

int* hirsch_dna_ss_dyn(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm, int* hirsch_path);
int* hirsch_align_two_dna_ss_vector(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm,int* hirsch_path,float input_states[],int old_cor[]);
struct states* foward_dyn(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm);
struct states* backward_dyn(const unsigned char* seq1,const unsigned char* seq2,struct hirsch_mem* hm);

struct hirsch_mem* hirsch_mem_alloc(struct hirsch_mem* hm,int x);
struct hirsch_mem* hirsch_mem_realloc(struct hirsch_mem* hm,int x);
void hirsch_mem_free(struct hirsch_mem* hm);


